// one-byte scancode table
uint8_t at_1byte[] = {
	0x00,
	HID_KEYBOARD_SC_F9,		// 0x01
	0x00,
	HID_KEYBOARD_SC_F5,		// 0x03
	HID_KEYBOARD_SC_F3,		// 0x04
	HID_KEYBOARD_SC_F1,		// 0x05
	HID_KEYBOARD_SC_F2,		// 0x06
	HID_KEYBOARD_SC_F12,	// 0x07
	0x00,
	HID_KEYBOARD_SC_F10,	// 0x09
	HID_KEYBOARD_SC_F8,		// 0x0A
	HID_KEYBOARD_SC_F6,		// 0x0B
	HID_KEYBOARD_SC_F4,		// 0x0C
	HID_KEYBOARD_SC_TAB,	// 0x0D
	HID_KEYBOARD_SC_NON_US_HASHMARK_AND_TILDE,	// 0x0E
	0x00,					// 0x0F
	0x00,					// 0x10
	0x00,					// 0x11
	0x00,					// 0x12
	0x00,					// 0x13
	0x00,					// 0x14
	HID_KEYBOARD_SC_Q,		// 0x15
	HID_KEYBOARD_SC_1_AND_EXCLAMATION,	// 0x16
	0x00,					// 0x17
	0x00,					// 0x18
	0x00,					// 0x19
	HID_KEYBOARD_SC_Z,		// 0x1A
	HID_KEYBOARD_SC_S,		// 0x1B
	HID_KEYBOARD_SC_A,		// 0x1C
	HID_KEYBOARD_SC_W,		// 0x1D
	HID_KEYBOARD_SC_2_AND_AT,	// 0x1E
	0x00,					// 0x1F
	0x00,					// 0x20
	HID_KEYBOARD_SC_C,		// 0x21
	HID_KEYBOARD_SC_X,		// 0x22
	HID_KEYBOARD_SC_D,		// 0x23
	HID_KEYBOARD_SC_E,		// 0x24
	HID_KEYBOARD_SC_4_AND_DOLLAR,	// 0x25
	HID_KEYBOARD_SC_3_AND_HASHMARK,	// 0x26
	0x00,					// 0x27
	0x00,					// 0x28
	HID_KEYBOARD_SC_SPACE,	// 0x29
	HID_KEYBOARD_SC_V,		// 0x2A
	HID_KEYBOARD_SC_F,		// 0x2B
	HID_KEYBOARD_SC_T,		// 0x2C
	HID_KEYBOARD_SC_R,		// 0x2D
	HID_KEYBOARD_SC_5_AND_PERCENTAGE,	// 0x2E
	0x00,					// 0x2F
	0x00,					// 0x30
	HID_KEYBOARD_SC_N,		// 0x31
	HID_KEYBOARD_SC_B,		// 0x32
	HID_KEYBOARD_SC_H,		// 0x33
	HID_KEYBOARD_SC_G,		// 0x34
	HID_KEYBOARD_SC_Y,		// 0x35
	HID_KEYBOARD_SC_6_AND_CARET,	// 0x36
	0x00,					// 0x37
	0x00,					// 0x38
	0x00,					// 0x39
	HID_KEYBOARD_SC_M,		// 0x3A
	HID_KEYBOARD_SC_J,		// 0x3B
	HID_KEYBOARD_SC_U,		// 0x3C
	HID_KEYBOARD_SC_7_AND_AND_AMPERSAND,	// 0x3D
	HID_KEYBOARD_SC_8_AND_ASTERISK,	// 0x3E
	0x00,					// 0x3F
	0x00,					// 0x40
	HID_KEYBOARD_SC_COMMA_AND_LESS_THAN_SIGN,	// 0x41
	HID_KEYBOARD_SC_K,		// 0x42
	HID_KEYBOARD_SC_I,		// 0x43
	HID_KEYBOARD_SC_O,		// 0x44
	HID_KEYBOARD_SC_0_AND_CLOSING_PARENTHESIS,	// 0x45
	HID_KEYBOARD_SC_9_AND_OPENING_PARENTHESIS,	// 0x46
	0x00,					// 0x47
	0x00,					// 0x48
	HID_KEYBOARD_SC_DOT_AND_GREATER_THAN_SIGN,	// 0x49
	HID_KEYBOARD_SC_SLASH_AND_QUESTION_MARK,	// 0x4A
	HID_KEYBOARD_SC_L,		// 0x4B
	HID_KEYBOARD_SC_SEMICOLON_AND_COLON,	// 0x4C
	HID_KEYBOARD_SC_P,		// 0x4D
	HID_KEYBOARD_SC_MINUS_AND_UNDERSCORE,	// 0x4E
	0x00,					// 0x4F
	0x00,					// 0x50
	0x00,					// 0x51
	HID_KEYBOARD_SC_APOSTROPHE_AND_QUOTE,	// 0x52
	0x00,					// 0x53
	HID_KEYBOARD_SC_OPENING_BRACKET_AND_OPENING_BRACE,	// 0x54
	HID_KEYBOARD_SC_EQUAL_AND_PLUS,	// 0x55
	0x00,					// 0x56
	0x00,					// 0x57
	HID_KEYBOARD_SC_CAPS_LOCK,	// 0x58
	0x00,					// 0x59
	HID_KEYBOARD_SC_ENTER,	// 0x5A
	HID_KEYBOARD_SC_CLOSING_BRACKET_AND_CLOSING_BRACE,	// 0x5B
	0x00,					// 0x5C
	HID_KEYBOARD_SC_BACKSLASH_AND_PIPE,	// 0x5D
	0x00,					// 0x5E
	0x00,					// 0x5F
	0x00,					// 0x60
	0x00,					// 0x61
	0x00,					// 0x62
	0x00,					// 0x63
	0x00,					// 0x64
	0x00,					// 0x65
	HID_KEYBOARD_SC_BACKSPACE,	// 0x66
	0x00,					// 0x67
	0x00,					// 0x68
	HID_KEYBOARD_SC_KEYPAD_1_AND_END,	// 0x69
	0x00,					// 0x6A
	HID_KEYBOARD_SC_KEYPAD_4_AND_LEFT_ARROW,	// 0x6B
	HID_KEYBOARD_SC_KEYPAD_7_AND_HOME,	// 0x6C
	0x00,					// 0x6D
	0x00,					// 0x6E
	0x00,					// 0x6F
	HID_KEYBOARD_SC_KEYPAD_0_AND_INSERT,	// 0x70
	HID_KEYBOARD_SC_KEYPAD_DOT_AND_DELETE,	// 0x71
	HID_KEYBOARD_SC_KEYPAD_2_AND_DOWN_ARROW,	// 0x72
	HID_KEYBOARD_SC_KEYPAD_5,	// 0x73
	HID_KEYBOARD_SC_KEYPAD_6_AND_RIGHT_ARROW,	// 0x74
	HID_KEYBOARD_SC_KEYPAD_8_AND_UP_ARROW,	// 0x75
	HID_KEYBOARD_SC_ESCAPE,	// 0x76
	HID_KEYBOARD_SC_NUM_LOCK,	// 0x77
	HID_KEYBOARD_SC_F11,	// 0x78
	HID_KEYBOARD_SC_KEYPAD_PLUS,	// 0x79
	HID_KEYBOARD_SC_KEYPAD_3_AND_PAGE_DOWN,	// 0x7A
	HID_KEYBOARD_SC_KEYPAD_MINUS,	// 0x7B
	HID_KEYBOARD_SC_KEYPAD_ASTERISK,	// 0x7C
	HID_KEYBOARD_SC_KEYPAD_9_AND_PAGE_UP,	// 0x7D
	HID_KEYBOARD_SC_SCROLL_LOCK,	// 0x7E
	0x00,					// 0x7F
	0x00,					// 0x80
	0x00,					// 0x81
	0x00,					// 0x82
	HID_KEYBOARD_SC_F7,		// 0x83
	0x00,					// 0x84
	0x00,					// 0x85
	0x00,					// 0x86
	0x00,					// 0x87
	0x00,					// 0x88
	0x00,					// 0x89
	0x00,					// 0x8A
	0x00,					// 0x8B
	0x00,					// 0x8C
	0x00,					// 0x8D
	0x00,					// 0x8E
	0x00,					// 0x8F
	0x00,					// 0x90
	0x00,					// 0x91
	0x00,					// 0x92
	0x00,					// 0x93
	0x00,					// 0x94
	0x00,					// 0x95
	0x00,					// 0x96
	0x00,					// 0x97
	0x00,					// 0x98
	0x00,					// 0x99
	0x00,					// 0x9A
	0x00,					// 0x9B
	0x00,					// 0x9C
	0x00,					// 0x9D
	0x00,					// 0x9E
	0x00,					// 0x9F
	0x00,					// 0xA0
	0x00,					// 0xA1
	0x00,					// 0xA2
	0x00,					// 0xA3
	0x00,					// 0xA4
	0x00,					// 0xA5
	0x00,					// 0xA6
	0x00,					// 0xA7
	0x00,					// 0xA8
	0x00,					// 0xA9
	0x00,					// 0xAA
	0x00,					// 0xAB
	0x00,					// 0xAC
	0x00,					// 0xAD
	0x00,					// 0xAE
	0x00,					// 0xAF
	0x00,					// 0xB0
	0x00,					// 0xB1
	0x00,					// 0xB2
	0x00,					// 0xB3
	0x00,					// 0xB4
	0x00,					// 0xB5
	0x00,					// 0xB6
	0x00,					// 0xB7
	0x00,					// 0xB8
	0x00,					// 0xB9
	0x00,					// 0xBA
	0x00,					// 0xBB
	0x00,					// 0xBC
	0x00,					// 0xBD
	0x00,					// 0xBE
	0x00,					// 0xBF
	0x00,					// 0xC0
	0x00,					// 0xC1
	0x00,					// 0xC2
	0x00,					// 0xC3
	0x00,					// 0xC4
	0x00,					// 0xC5
	0x00,					// 0xC6
	0x00,					// 0xC7
	0x00,					// 0xC8
	0x00,					// 0xC9
	0x00,					// 0xCA
	0x00,					// 0xCB
	0x00,					// 0xCC
	0x00,					// 0xCD
	0x00,					// 0xCE
	0x00,					// 0xCF
	0x00,					// 0xD0
	0x00,					// 0xD1
	0x00,					// 0xD2
	0x00,					// 0xD3
	0x00,					// 0xD4
	0x00,					// 0xD5
	0x00,					// 0xD6
	0x00,					// 0xD7
	0x00,					// 0xD8
	0x00,					// 0xD9
	0x00,					// 0xDA
	0x00,					// 0xDB
	0x00,					// 0xDC
	0x00,					// 0xDD
	0x00,					// 0xDE
	0x00,					// 0xDF
	0x00,					// 0xE0
	0x00,					// 0xE1
	0x00,					// 0xE2
	0x00,					// 0xE3
	0x00,					// 0xE4
	0x00,					// 0xE5
	0x00,					// 0xE6
	0x00,					// 0xE7
	0x00,					// 0xE8
	0x00,					// 0xE9
	0x00,					// 0xEA
	0x00,					// 0xEB
	0x00,					// 0xEC
	0x00,					// 0xED
	0x00,					// 0xEE
	0x00,					// 0xEF
	0x00,					// 0xF0
	0x00,					// 0xF1
	0x00,					// 0xF2
	0x00,					// 0xF3
	0x00,					// 0xF4
	0x00,					// 0xF5
	0x00,					// 0xF6
	0x00,					// 0xF7
	0x00,					// 0xF8
	0x00,					// 0xF9
	0x00,					// 0xFA
	0x00,					// 0xFB
	0x00,					// 0xFC
	0x00,					// 0xFD
	0x00,					// 0xFE
	0x00					// 0xFF
};

// two-byte scancode table
uint8_t at_2byte[] = {
	0x00,					// 0x00
	0x00,					// 0x01
	0x00,					// 0x02
	0x00,					// 0x03
	0x00,					// 0x04
	0x00,					// 0x05
	0x00,					// 0x06
	0x00,					// 0x07
	0x00,					// 0x08
	0x00,					// 0x09
	0x00,					// 0x0A
	0x00,					// 0x0B
	0x00,					// 0x0C
	0x00,					// 0x0D
	0x00,					// 0x0E
	0x00,					// 0x0F
	0x00,					// 0x10
	0x00,					// 0x11
	0x00,					// 0x12
	0x00,					// 0x13
	0x00,					// 0x14
	0x00,					// 0x15
	0x00,					// 0x16
	0x00,					// 0x17
	0x00,					// 0x18
	0x00,					// 0x19
	0x00,					// 0x1A
	0x00,					// 0x1B
	0x00,					// 0x1C
	0x00,					// 0x1D
	0x00,					// 0x1E
	0x00,					// 0x1F
	0x00,					// 0x20
	0x00,					// 0x21
	0x00,					// 0x22
	0x00,					// 0x23
	0x00,					// 0x24
	0x00,					// 0x25
	0x00,					// 0x26
	0x00,					// 0x27
	0x00,					// 0x28
	0x00,					// 0x29
	0x00,					// 0x2A
	0x00,					// 0x2B
	0x00,					// 0x2C
	0x00,					// 0x2D
	0x00,					// 0x2E
	0x00,					// 0x2F
	0x00,					// 0x30
	0x00,					// 0x31
	0x00,					// 0x32
	0x00,					// 0x33
	0x00,					// 0x34
	0x00,					// 0x35
	0x00,					// 0x36
	0x00,					// 0x37
	0x00,					// 0x38
	0x00,					// 0x39
	0x00,					// 0x3A
	0x00,					// 0x3B
	0x00,					// 0x3C
	0x00,					// 0x3D
	0x00,					// 0x3E
	0x00,					// 0x3F
	0x00,					// 0x40
	0x00,					// 0x41
	0x00,					// 0x42
	0x00,					// 0x43
	0x00,					// 0x44
	0x00,					// 0x45
	0x00,					// 0x46
	0x00,					// 0x47
	0x00,					// 0x48
	0x00,					// 0x49
	HID_KEYBOARD_SC_KEYPAD_SLASH,	// 0x4A
	0x00,					// 0x4B
	0x00,					// 0x4C
	0x00,					// 0x4D
	0x00,					// 0x4E
	0x00,					// 0x4F
	0x00,					// 0x50
	0x00,					// 0x51
	0x00,					// 0x52
	0x00,					// 0x53
	0x00,					// 0x54
	0x00,					// 0x55
	0x00,					// 0x56
	0x00,					// 0x57
	0x00,					// 0x58
	0x00,					// 0x59
	HID_KEYBOARD_SC_KEYPAD_ENTER,	// 0x5A
	0x00,					// 0x5B
	0x00,					// 0x5C
	0x00,					// 0x5D
	0x00,					// 0x5E
	0x00,					// 0x5F
	0x00,					// 0x60
	0x00,					// 0x61
	0x00,					// 0x62
	0x00,					// 0x63
	0x00,					// 0x64
	0x00,					// 0x65
	0x00,					// 0x66
	0x00,					// 0x67
	0x00,					// 0x68
	HID_KEYBOARD_SC_END,	// 0x69
	0x00,					// 0x6A
	HID_KEYBOARD_SC_LEFT_ARROW,	// 0x6B
	HID_KEYBOARD_SC_HOME,	// 0x6C
	0x00,					// 0x6D
	0x00,					// 0x6E
	0x00,					// 0x6F
	HID_KEYBOARD_SC_INSERT,	// 0x70
	HID_KEYBOARD_SC_DELETE,	// 0x71
	HID_KEYBOARD_SC_DOWN_ARROW,	// 0x72
	0x00,					// 0x73
	HID_KEYBOARD_SC_RIGHT_ARROW,	// 0x74
	HID_KEYBOARD_SC_UP_ARROW,	// 0x75
	0x00,					// 0x76
	0x00,					// 0x77
	0x00,					// 0x78
	0x00,					// 0x79
	HID_KEYBOARD_SC_PAGE_DOWN,	// 0x7A
	0x00,					// 0x7B
	0x00,					// 0x7C
	HID_KEYBOARD_SC_PAGE_UP,	// 0x7D
	0x00,					// 0x7E
	0x00,					// 0x7F
	0x00,					// 0x80
	0x00,					// 0x81
	0x00,					// 0x82
	0x00,					// 0x83
	0x00,					// 0x84
	0x00,					// 0x85
	0x00,					// 0x86
	0x00,					// 0x87
	0x00,					// 0x88
	0x00,					// 0x89
	0x00,					// 0x8A
	0x00,					// 0x8B
	0x00,					// 0x8C
	0x00,					// 0x8D
	0x00,					// 0x8E
	0x00,					// 0x8F
	0x00,					// 0x90
	0x00,					// 0x91
	0x00,					// 0x92
	0x00,					// 0x93
	0x00,					// 0x94
	0x00,					// 0x95
	0x00,					// 0x96
	0x00,					// 0x97
	0x00,					// 0x98
	0x00,					// 0x99
	0x00,					// 0x9A
	0x00,					// 0x9B
	0x00,					// 0x9C
	0x00,					// 0x9D
	0x00,					// 0x9E
	0x00,					// 0x9F
	0x00,					// 0xA0
	0x00,					// 0xA1
	0x00,					// 0xA2
	0x00,					// 0xA3
	0x00,					// 0xA4
	0x00,					// 0xA5
	0x00,					// 0xA6
	0x00,					// 0xA7
	0x00,					// 0xA8
	0x00,					// 0xA9
	0x00,					// 0xAA
	0x00,					// 0xAB
	0x00,					// 0xAC
	0x00,					// 0xAD
	0x00,					// 0xAE
	0x00,					// 0xAF
	0x00,					// 0xB0
	0x00,					// 0xB1
	0x00,					// 0xB2
	0x00,					// 0xB3
	0x00,					// 0xB4
	0x00,					// 0xB5
	0x00,					// 0xB6
	0x00,					// 0xB7
	0x00,					// 0xB8
	0x00,					// 0xB9
	0x00,					// 0xBA
	0x00,					// 0xBB
	0x00,					// 0xBC
	0x00,					// 0xBD
	0x00,					// 0xBE
	0x00,					// 0xBF
	0x00,					// 0xC0
	0x00,					// 0xC1
	0x00,					// 0xC2
	0x00,					// 0xC3
	0x00,					// 0xC4
	0x00,					// 0xC5
	0x00,					// 0xC6
	0x00,					// 0xC7
	0x00,					// 0xC8
	0x00,					// 0xC9
	0x00,					// 0xCA
	0x00,					// 0xCB
	0x00,					// 0xCC
	0x00,					// 0xCD
	0x00,					// 0xCE
	0x00,					// 0xCF
	0x00,					// 0xD0
	0x00,					// 0xD1
	0x00,					// 0xD2
	0x00,					// 0xD3
	0x00,					// 0xD4
	0x00,					// 0xD5
	0x00,					// 0xD6
	0x00,					// 0xD7
	0x00,					// 0xD8
	0x00,					// 0xD9
	0x00,					// 0xDA
	0x00,					// 0xDB
	0x00,					// 0xDC
	0x00,					// 0xDD
	0x00,					// 0xDE
	0x00,					// 0xDF
	0x00,					// 0xE0
	0x00,					// 0xE1
	0x00,					// 0xE2
	0x00,					// 0xE3
	0x00,					// 0xE4
	0x00,					// 0xE5
	0x00,					// 0xE6
	0x00,					// 0xE7
	0x00,					// 0xE8
	0x00,					// 0xE9
	0x00,					// 0xEA
	0x00,					// 0xEB
	0x00,					// 0xEC
	0x00,					// 0xED
	0x00,					// 0xEE
	0x00,					// 0xEF
	0x00,					// 0xF0
	0x00,					// 0xF1
	0x00,					// 0xF2
	0x00,					// 0xF3
	0x00,					// 0xF4
	0x00,					// 0xF5
	0x00,					// 0xF6
	0x00,					// 0xF7
	0x00,					// 0xF8
	0x00,					// 0xF9
	0x00,					// 0xFA
	0x00,					// 0xFB
	0x00,					// 0xFC
	0x00,					// 0xFD
	0x00,					// 0xFE
	0x00					// 0xFF
};
